(function($) {
	$.fn.Carousel = function(options) {
		var settings = $.extend({
			paddingLR: 0.5,
			speed: 300,
			auto: true,
			interval: 15000
		}, options);

		return this.each (function() {
			//Variable
			var $baseObj = $(this);
			var $img = $baseObj.find('.img');
			var $imgUl = $img.find('ul');
			var $imgLi = $imgUl.find('li');
			var $pager;
			var $pagerLi;
			var imgLength = $imgLi.length;
			var windowWidth;
			var imgWidth;
			var maxpoint;
			var autoTimer;
			var scrollWidth = function() {
				return $imgUl.find('li').find('img').width() + Number($imgLi.css('paddingLeft').replace('px', '')) * 2;
			};
			var pagerHtml = ''+
				'<ul class="pager">'+
				'<li class="prev disabled">Prev</li>'+
				'<li class="next">Next</li>'+
				'</ul>'
			;
			var imgnun = $('.carousel li').length - 1;
    		
			var currentHtml = ''+
				'<div class="pointer">'+
				'<span class="current"></span>'+
				'</div>'
			;
			var flipsnap;

			function init() {
				$baseObj.append(pagerHtml);
				$baseObj.append(currentHtml);
				$imgUl.addClass('flipsnap');
				$pager = $baseObj.find('.pager');
				$pagerLi = $pager.find('li');
				$basePointer = $baseObj.find('.pointer');
				for (var i = 0; i < imgnun; i++) {
					$basePointer.append('<span></span>');
				}
				$pointer = $baseObj.find('.pointer span');
				$imgLi.css({
					paddingLeft: settings.paddingLR + '%',
					paddingRight: settings.paddingLR + '%'
				});

				setEvent();
			};

			function setFrameSize(columnNum) {
				maxpoint = imgLength - columnNum;
				if(maxpoint < 0) maxpoint = 0;

				$imgUl.css({
					width: (100 * imgLength) / columnNum + '%'
				});
				$imgLi.css({
					width: (100 / imgLength) - (settings.paddingLR * 2) + '%'
				});

				$pagerLi.first().addClass('disabled');
			};

			function setEvent() {
				//Resize
				var timerID = false;
				$(window).resize(function() {
					if (timerID !== false) {
						clearTimeout(timerID);
					};
					timerID = setTimeout(function() {
						getWindowSize();
					}, 200);
				});

				flipsnap = Flipsnap('.flipsnap', {
					distance: scrollWidth(),
					maxPoint: maxpoint,
					disableTouch: true
				});

				flipsnap.element.addEventListener('fspointmove', function() {
					setAuto();
					detectEnd();
					$pointer.filter('.current').removeClass('current');
					$pointer.eq(flipsnap.currentPoint).addClass('current');
				}, false);
				flipsnap.element.addEventListener('fstouchend', function() {
					setAuto();
				}, false);
				flipsnap.element.addEventListener('fstouchstart', function() {
					clearTimeout(autoTimer);
				}, false);

				//First trigger
				setAuto();

				getWindowSize();
			};

			function getWindowSize() {
				windowWidth = $(window).width();
				divideEvent();
			};

			function divideEvent() {
				$pagerLi.off('click');
				$imgUl.css({'transform':'translate3d(0,0,0)'});

				if(windowWidth <= 480) {
					setFrameSize(1);
					resetFlipSnap(false);
				} else if(windowWidth <= 640) {
					setFrameSize(2);
					resetFlipSnap(false);
				} else {
					setFrameSize(4);
					resetFlipSnap(true);
				};

				$pagerLi.on('click', function() {
					action($(this).index());
				});

				detectEnd();
			};

			function resetFlipSnap(bool) {
				flipsnap.distance = scrollWidth();
				flipsnap.disableTouch = bool;
				flipsnap.maxPoint = maxpoint;
				flipsnap.refresh();
			};

			function action(direction) {
				if(direction == 0) {
					flipsnap.toPrev();
				} else {
					flipsnap.toNext();
				};

				detectEnd();
			};

			function detectEnd() {
				if(!flipsnap.hasPrev()) {
					$pagerLi.first().addClass('disabled');
				} else {
					$pagerLi.first().removeClass('disabled');
				};
				if(!flipsnap.hasNext()) {
					$pagerLi.last().addClass('disabled');
				} else {
					$pagerLi.last().removeClass('disabled');
				};
			}

			function setAuto() {
				if(settings.auto) {
					clearTimeout(autoTimer);

					if(imgLength > 1) {
						autoTimer = setTimeout(function() {
							if(!flipsnap.hasNext()) {
								flipsnap.moveToPoint(0);
								$pagerLi.removeClass('disabled').eq(0).addClass('disabled');
							} else {
								action(1);
							};
						}, settings.interval);
					};
				};
			};

			init();
		});

		return this;
	};

	$(window).on('load', function() {
		//For IE
		var _ieVersion = (function(_doc, reg) {
			return _doc.documentMode ? _doc.documentMode :
			/*@cc_on!@*/false && navigator.userAgent.match(reg) ? RegExp.$1 * 1 : 0;
		})(document, /MSIE\s([0-9]+[\.0-9]*)/),
		_isMSIE = _ieVersion > 0 ? true : false;
		if(_isMSIE == true) {
			if(_ieVersion <= 8 ) {
				$('body').addClass('ltIE8');
				return;
			};
		};

		$('.carousel').Carousel();
	});
})(jQuery);